
/* 
   Luis C. Aparicio

        Sistemas Operativos
        rea de Arquitectura y Tecnologa de computadores

   Programa servidor de suma utilizando sockets stream (TCP) 
 
   servTCP.c
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>

int main()
{
  struct sockaddr_in server_addr, client_addr;

  int sd, sc, salir;
  int size, res;
  int num[2];

  sd = socket(AF_INET, SOCK_STREAM, 0);

  /* Asigna la direccin al socket */
  bzero((char *)&server_addr, sizeof(server_addr));
  server_addr.sin_family = AF_INET;
  server_addr.sin_addr.s_addr = INADDR_ANY;//SE UTILIZA  PARA RESTRINGIR EL ACCESO AL SERVICIO
  server_addr.sin_port = htons(5555);

  bind(sd, &server_addr, sizeof(server_addr));//REGISTRA EL SERVIDOR

  listen(sd, 5);//CREA COLA DE ESPERA DE 5

  size = sizeof(client_addr);
  salir = 0;

  while (salir == 0)
  {
    printf("Esperando conexin en el puerto: 5500\n"); fflush(stdout);
    sc = accept(sd, (struct sockaddr *)&client_addr, &size);//ESCUCHA SOLICITUDES DE CONEXION Y CREA SOCKET SI SE PRODUCEN
    if(sc < 0) salir = 1;
    else
    {
      /* recibe la peticin, dos nmero enteros */
      //read(sc, (char*) num, 2*sizeof(int));
      read(sc, &num, 2*sizeof(int));//LEE DEL SOCKET
      res = num[0] + num[1];

      printf("\nServicio: %d + %d = %d \n", num[0], num[1], res); fflush(stdout);

      /* enva el resultado y cierra la conexin */
      //write(sc, (char*)&res, sizeof(int));
      write(sc, &res, sizeof(int));//ENVIA EL RESULTADO
      close (sc);//CIERRA EL SOCKET TEMPORAL
    }
  }

  printf("\n Error en accept \n"); fflush(stdout);
  close(sd);//CIERRA SOCKET PRINCIPAL

  exit(0);
}
//COMPILAR CON: gcc -o sT servTCP.c -lsocket -lnsl
//EJECUTAR CON:
