
/*     Sistemas Operativos II     */
/*     prac7.c     */

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

void pr_exit(int estado);

int main(int argc, char *argv[])
{
  int status;

  if (argc < 2)
  {
    perror("Se requiere como argumento una lnea de orden");
    exit(1);
  }

  if ((status = system(argv[1])) < 0) perror ("system() error");
  pr_exit(status);

  exit(0);
}

void pr_exit(int estado)
{
  if (WIFEXITED(estado)) printf("Terminacin normal, exit status = %d\n", WEXITSTATUS(estado));
  else if (WIFSIGNALED(estado))
  {
    printf("Terminacin anormal, numero de signal = %d ", WTERMSIG(estado));
    if (WCOREDUMP(estado)) printf("(se genero fichero core)\n");
    else printf(" \n");
  }
  else if (WIFSTOPPED(estado)) printf("Hijo detenido, numero de signal = %d\n", WSTOPSIG(estado));
}
